$(document).ready(function()
{
    $(document).on('click', 'td.child .addItem', function()
    {  
        var child = $(this).parents('table').data('child');    
        $(this).closest('tr').after($('.table-'+ child +' tbody').html());
        $(this).closest('tr').next().find('.chosen').next('.chosen-container').remove();
        $(this).closest('tr').next().find('.chosen').chosen(window.chosenDefaultOptions);
        $(this).closest('tr').next().find('.form-date, .form-datetime').datetimepicker(
        {
            language:  config.clientLang,
            weekStart: 1,
            todayBtn:  1,
            autoclose: 1,
            todayHighlight: 1,
            startView: 2,
            minView: 2,
            forceParse: 0,
            format: 'yyyy-mm-dd'
        });        
    });

    $(document).on('click', 'td.child .delItem', function()
    {  
        if($(this).parents('.table-child').find('tr').size() > 1)
        {
            $(this).closest('tr').remove();
        }
        else
        {
            $(this).closest('tr').find('input,select,textarea').val('');
        }
    })

    $('.reloadPage').click(function()
    {
        url = $(this).attr('href');

        $.getJSON(url, function(response)
        {
            if(response.message)
            {
                bootbox.alert(response.message, function()
                {
                    if(response.locate) 
                    {
                        location.href = response.locate;
                        return false;
                    }
                    location.reload();
                });
            }
            else
            {
                if(response.locate) 
                {
                    location.href = response.locate;
                    return false;
                }
                location.reload();
            }
        });
        return false;
    });

    $('.prevP').each(function()
    {
        loadPrevData($(this), 'p');
    });

    $('.prevTR').each(function()
    {
        loadPrevData($(this), 'tr');
    });
})

function loadPrevData($selector, element)
{
    var prev   = $selector.data('prev');
    var next   = $selector.data('next');
    var action = $selector.data('action');
    var field  = $selector.data('field');
    var dataID = $selector.data('dataid');

    $('.prevData.' + field).remove();

    var link = createLink('flow', 'ajaxGetPrevData', 'prev=' + prev + '&next=' + next + '&action=' + action + '&dataID=' + dataID);
    $.get(link, function(prevData)
    {
        if(!prevData) return false;

        prevData = JSON.parse(prevData);
        for(var i in prevData)
        {
            var name  = prevData[i].name;
            var value = prevData[i].value;

            if(element == 'p')  $selector.after("<p class='prevData " + field + "'>" + name + ' : ' + value + '<p>');
            if(element == 'tr') $selector.after("<tr class='prevData " + field + "'><th>" + name + '</th><td>' + value + '</td></tr>');
        }
    });
}
