<table class='table table-borderless'>
  <thead>
    <tr class='text-center'>
      <?php
      foreach($fields as $field)
      {
          if(!$field->show) continue;

          $width    = $field->width == 'auto' ? '' : 'w-' . $field->width . 'px';
          $required = strpos(",$field->rules,", ",$notEmptyRule->id,") !== false ? 'required' : '';
          echo "<th class='$width $required'>$field->name</th>";
      }
      if(empty($dataList)) echo "<th class='w-100px'>$lang->actions</th>";
      ?>
    </tr>
  </thead>
  <tbody>
    <?php
    if($action->action == 'batchcreate')
    {
        if(empty($dataList))
        {
            /* Batch create of the current flow. */
            for($i = 0; $i < $config->flow->batchCreateRow; $i++)
            {
                echo "<tr data-key='$i'>";

                $index = 1;
                foreach($fields as $field)
                {
                    if(!$field->show) continue;

                    echo '<td>';

                    echo $this->flow->buildControl($field, $field->defaultValue, "dataList[$i][$field->field]");
                    if($index == 1) echo "<div id='error{$i}'></div>";

                    echo '</td>';

                    $index++;
                }

                echo '<td>';
                echo "<a href='javascript:;' class='btn addItem'><i class='icon icon-plus'></i></a>";
                echo "<a href='javascript:;' class='btn delItem'><i class='icon icon-remove'></i></a>";
                echo '</td>';
                echo '</tr>';
            }
        }
        else
        {
            /* Batch create from the prev flow. */
            foreach($dataList as $dataID)
            {
                echo '<tr>';

                $index = 1;
                foreach($fields as $field)
                {
                    if(!$field->show) continue;

                    $value = $field->field == $prevField ? $dataID : $field->defaultValue;

                    echo '<td>';

                    echo $this->flow->buildControl($field, $value, "dataList[$dataID][$field->field]");
                    if($index == 1) echo "<div id='error{$dataID}'></div>";

                    echo '</td>';

                    $index++;
                }

                echo '</tr>';
            }
        }
    }
    else
    {
        /* Batch edit of the current flow. */
        foreach($dataList as $data)
        {
            echo '<tr>';

            $index = 1;
            foreach($fields as $field)
            {
                if(!$field->show) continue;

                $value = isset($data->{$field->field}) ? $data->{$field->field} : $field->defaultValue;

                echo '<td>';

                echo $this->flow->buildControl($field, $value, "dataList[$data->id][$field->field]");
                if($index == 1) echo "<div id='error{$data->id}'></div>";

                echo '</td>';

                $index++;
            }

            echo '</tr>';
        }
    }
    ?>
  </tbody>
</table>
<div class='form-actions text-center'>
  <?php echo baseHTML::submitButton();?>
  <?php echo html::backButton();?>
</div>
