<?php
helper::import(dirname(dirname(dirname(__FILE__))) . "/control.php");
class myStory extends story
{
    public function create($productID = 0, $branch = 0, $moduleID = 0, $storyID = 0, $projectID = 0, $bugID = 0, $planID = 0, $todoID = 0, $extra = '')
    {
        if($extra)
        {
            $extras = str_replace(array(',', ' '), array('&', ''), $extra);
            parse_str($extras, $params);
            foreach($params as $varName => $varValue) $$varName = $varValue;
        }
        if(!empty($feedbackID))
        {
            $feedback = $this->loadModel('feedback')->getById($feedbackID);
            $actions  = $this->loadModel('action')->getList('feedback', $feedbackID);
            if(!$feedback) die(js::error($this->lang->notFound) . js::locate('back', 'parent'));
            $feedbackOpenedBy = $this->loadModel('user')->getById($feedback->openedBy);
            foreach($actions as $action)
            {   
                if($action->action == 'reviewed' and $action->comment)
                {   
                    $feedback->desc .= $feedback->desc ? '<br/>' . $this->lang->feedback->reviewOpinion . '：' . $action->comment : $this->lang->feedback->reviewOpinion . '：' . $action->comment;
                }   
            }

            if(!empty($_POST))
            {
                $response['result']  = 'success';
                $response['message'] = '';

                $storyResult = $this->story->create($projectID, $bugID);
                if(!$storyResult or dao::isError())
                {
                    $response['result']  = 'fail';
                    $response['message'] = dao::getError();
                    $this->send($response);
                }

                $storyID = $storyResult['id'];
                if($storyResult['status'] == 'exists')
                {
                    $response['message'] = sprintf($this->lang->duplicate, $this->lang->story->common);
                    $response['locate']  = $this->createLink('story', 'view', "storyID={$storyID}");
                    $this->send($response);
                }

                $actionID = $this->action->create('story', $storyID, 'FromFeedback', '', $feedbackID);
                $this->story->sendmail($storyID, $actionID);
                $this->loadModel('feedback')->sendmail($feedbackID, $actionID);
                $this->loadModel('feedback')->sendmail($feedbackID, $actionID, 'openedBy');
                if($this->post->newStory)
                {
                    $response['message'] = $this->lang->story->successSaved . $this->lang->story->newStory;
                    $response['locate']  = $this->createLink('story', 'create', "productID=$productID&branch=$branch&moduleID=$moduleID&story=0&projectID=$projectID&bugID=$bugID");
                    $this->send($response);
                }
                $response['locate'] = $this->createLink('story', 'view', "storyID=$storyID");
                $this->send($response);
            }

            /* Set products, users and module. */
            $products = $this->product->getPairs('noclosed');
            $product  = $this->product->getById($productID ? $productID : key($products));
            if(!isset($products[$product->id])) $products[$product->id] = $product->name;

            $users = $this->user->getPairs('pdfirst|noclosed|nodeleted');
            $moduleOptionMenu = $this->tree->getOptionMenu($productID, $viewType = 'story', 0, $branch);

            /* Set menu. */
            $this->product->setMenu($products, $product->id, $branch);

            /* Init vars. */
            $pri       = 0;
            $estimate  = '';
            $verify    = '';
            $keywords  = '';
            $mailto    = '';

            /* Set Custom*/
            foreach(explode(',', $this->config->story->list->customCreateFields) as $field) $customFields[$field] = $this->lang->story->$field;
            $this->view->customFields = $customFields;
            $this->view->showFields   = $this->config->story->custom->createFields;

            $this->view->title            = $product->name . $this->lang->colon . $this->lang->story->create;
            $this->view->position[]       = html::a($this->createLink('product', 'browse', "product=$productID&branch=$branch"), $product->name);
            $this->view->position[]       = $this->lang->story->common;
            $this->view->position[]       = $this->lang->story->create;
            $this->view->products         = $products;
            $this->view->users            = $users;
            $this->view->moduleID         = $moduleID;
            $this->view->moduleOptionMenu = $moduleOptionMenu;
            $this->view->plans            = $this->loadModel('productplan')->getPairs($productID, $branch, 'unexpired');
            $this->view->planID           = $planID;
            $this->view->source           = $feedbackOpenedBy->role;
            $this->view->sourceNote       = $feedbackOpenedBy->realname;
            $this->view->pri              = $pri;
            $this->view->branch           = $branch;
            $this->view->branches         = $product->type != 'normal' ? $this->loadModel('branch')->getPairs($productID) : array();
            $this->view->productID        = $feedback->product;
            $this->view->product          = $product;
            $this->view->projectID        = $projectID;
            $this->view->feedbackID       = $feedbackID;
            $this->view->estimate         = $estimate;
            $this->view->storyTitle       = $feedback->title;
            $this->view->spec             = $feedback->desc;
            $this->view->verify           = $verify;
            $this->view->keywords         = $keywords;
            $this->view->mailto           = $mailto;
            $this->view->needReview       = ($this->app->user->account == $product->PO || $projectID > 0 || $this->config->story->needReview == 0) ? "checked='checked'" : "";

            $this->display();
        }
        else
        {
            return parent::create($productID, $branch, $moduleID, $storyID, $projectID, $bugID, $planID, $todoID, $extra);
        }
    }
}
