$(document).ready(function()
{
    $(document).on('change', '#app', function()
    {
        if($(this).val()) $('select#positionModule').load(createLink('workflow', 'ajaxGetAppMenus', 'app=' + $(this).val() + '&exclude=' + currentModule));
    });

    $('.flow-toggle').click(function()
    {
        var obj = $(this).find('i');
        if(obj.hasClass('icon-plus'))
        {
            obj.parents('tr').next('tr').show();
            obj.removeClass('icon-plus').addClass('icon-minus');
        }
        else if(obj.hasClass('icon-minus'))
        {
            obj.parents('tr').next('tr').hide();
            obj.removeClass('icon-minus').addClass('icon-plus');
        }
        return false;
    });

    $('a.mode-toggle').click(function()
    {
        var mode = $(this).data('mode');
        $('a.mode-toggle').removeClass('active');
        $(this).addClass('active');
        $('#cardMode, #listMode').hide();
        $('#' + mode + 'Mode').show();
        $('#cardMode').next().toggle(mode == 'card');
        $.cookie('flowViewType', mode, {path: "/"});
    })

    $(document).on('change', '[name^=next]', function()
    {
        processNext();

        var $field = $(this).parents('tr').find('[name^=field]');
        var field  = $field.val();
        var link   = createLink('workflowfield', 'ajaxGetField', 'module=' + $(this).val());
        $field.load(link, function(response)
        {
            $field.val(field).trigger('chosen:updated');
        });
    });

    $(document).on('click', '.addItem', function()
    {
        var $tr = $(this).parents('tr');
        $tr.after(itemRow.replace(/KEY/g, key));
        $tr.next().find('select').chosen();

        processNext();

        key++;
    });

    $(document).on('click', '.delItem', function()
    {
        var $tr = $(this).parents('tr');
        if($('.delItem').length == 1)
        {
            $tr.find('select').val('').trigger('chosen:updated');
            $tr.find('input[type=checkbox]').prop('checked', false);
            return false;
        }

        $tr.remove();

        processNext();
    });

    var type = $.cookie('flowViewType');
    if(typeof(type) == 'undefined' || type == '') type = 'card';
    $('#menuActions a[data-mode=' + type +']').click();
});

/**
 * Make sure each next module and field can be selected only once.
 *
 * @access public
 * @return void
 */
function processNext()
{
    $('[name^=next]').each(function()
    {
        var $this    = $(this);
        var selected = $this.val();
        $this.empty().append($('#templateNext').html());
        $('[name^=next]').not(this).each(function()
        {
            var next = $(this).val();
            if(next != 0) $this.find('option[value=' + next + ']').remove();
        });
        $this.val(selected).trigger('chosen:updated');
    });
}
