<?php
/**
 * The detail view file of workflowaction module of RanZhi.
 *
 * @copyright   Copyright 2009-2016 青岛易软天创网络科技有限公司(QingDao Nature Easy Soft Network Technology Co,LTD, www.cnezsoft.com)
 * @license     商业软件，非开源软件
 * @author      Gang Liu <liugan@cnezsoft.com>
 * @package     workflowaction
 * @version     $Id$
 * @link        http://www.ranzhico.com
 */
?>
<?php include '../../common/view/header.html.php';?>
<div class='main-row'>
  <div class='main-col col-9'>
    <div class='panel panel-block'>
      <div class='panel-heading'><strong><?php echo $lang->workflowaction->desc;?></strong></div>
      <div class='panel-body'>
        <?php echo $action->desc;?>
      </div>
    </div>
    <div class='main-actions'>
      <div class='btn-toolbar'>
        <?php
        $canSetCondition    = $this->workflowaction->isClickable($action, 'setCondition');
        $canSetLayout       = $this->workflowaction->isClickable($action, 'admin');
        $canSetVerification = $this->workflowaction->isClickable($action, 'setVerification');
        $canSetResult       = $this->workflowaction->isClickable($action, 'browse');
        $canSetNotice       = $this->workflowaction->isClickable($action, 'setnotice');

        if($canSetCondition) extCommonModel::printLink('workflowaction', 'setCondition', "id=$action->id", $lang->workflowaction->setCondition, "class='btn' data-toggle='modal'");
        if($canSetLayout) extCommonModel::printLink('workflowlayout', 'admin', "module=$action->module&action=$action->action", $lang->workflowaction->layout, "class='btn'");
        if($canSetVerification) extCommonModel::printLink('workflowaction', 'setVerification', "id=$action->id", $lang->workflowaction->setVerification, "class='btn'");
        if($canSetResult) extCommonModel::printLink('workflowhook', 'browse',  "action=$action->id", $lang->workflowaction->result, "class='btn'");
        if($canSetNotice) extCommonModel::printLink('workflowaction', 'setNotice',  "id=$action->id", $lang->workflowaction->setNotice, "class='btn' data-toggle='modal'");
        ?>
        <div class='divider'></div>
        <?php
        $isDefault = in_array($action->action, $config->workflowaction->defaultActions);
        extCommonModel::printLink('workflowaction', 'edit', "module=$action->module&id=$action->id", $lang->edit, "class='btn' data-toggle='modal' data-width='600'");
        if(!$action->buildin && !$isDefault) extCommonModel::printLink('workflowaction', 'delete', "id=$action->id", $lang->delete, "class='btn deleter'");
        ?>
        <div class='divider'></div>
        <?php extCommonModel::printLink('workflowaction', 'browse', "module=$action->module", $lang->goback, "class='btn'");?>
      </div>
    </div>
  </div>
  <div class='side-col col-3'>
    <div class='panel panel-block'>
      <div class='panel-heading'>
        <strong><?php echo $lang->basicInfo;?></strong>
      </div>
      <div class='panel-body'>
        <table class='table table-data'>
          <tr>
            <th class='w-70px'><?php echo $lang->workflowaction->name;?></th>
            <td><?php echo $action->name;?></td>
          </tr>
          <tr>
            <th><?php echo $lang->workflowaction->action;?></th>
            <td><?php echo $action->action;?></td>
          </tr>
          <?php if(!empty($action->open)):?>
          <tr>
            <th><?php echo $lang->workflowaction->open;?></th>
            <td><?php echo zget($lang->workflowaction->openList, $action->open);?></td>
          </tr>
          <?php endif;?>
          <?php if(!empty($action->position)):?>
          <tr>
            <th><?php echo $lang->workflowaction->position;?></th>
            <td><?php echo zget($lang->workflowaction->positionList, $action->position);?></td>
          </tr>
          <?php endif;?>
          <?php if(!empty($action->show)):?>
          <tr>
            <th><?php echo $lang->workflowaction->show;?></th>
            <td><?php echo zget($lang->workflowaction->showList, $action->show);?></td>
          </tr>
          <?php endif;?>
          <tr>
            <th><?php echo $lang->workflowaction->createdBy;?></th>
            <td><?php echo zget($users, $action->createdBy) . $lang->at . formatTime($action->createdDate, DT_DATETIME1);?></td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
<?php include '../../common/view/footer.html.php';?>
